<template lang="pug">
    .comments(v-if="isRoot")
        ReplyForm(v-if="isLoggedIn" :show-cancel="false" :parent_author="comment.author" :parent_permlink="comment.permlink" @success="addReply")
        p(v-else)
            a(href="/login") Login with Hivesigner
            | &nbsp;to be able to comment this article
        comments-tree(v-for="child in children" :comment="child")
    ul.comments-tree(v-else)
        li.comments-single
            img.comment-avatar(:src="`//images.hive.blog/u/${comment.author}/avatar`")
            .comment-content
                p.comment-meta
                    a.comment-meta-username(:href="`//peakd.com/@${comment.author}`") @{{ comment.author }}
                    span(:title='createdLocalTime | moment("DD MMMM YYYY, h:mm:ss")' aria-hidden="true")= ", " + "{{ createdLocalTime | moment('from') }}"
                EditForm(v-if="isEditActive" :comment="comment" @cancel="closeEditForm()" @success="updateComment")
                div(v-else)
                    p(v-if="hasLowRating && isHidden" @click="showHidden").low-rating Comment hidden due to low rating. Click to show
                    p(v-else v-html="comment.rendered")
                p.comment-actions
                    span.action
                        v-popover(:disabled="!isLoggedIn" )
                            i.fa.fa-thumbs-up.active-action(:class="{ voted: isVotedByUser }" :title="isVotedByUser ? 'Voted' : 'Vote!'")
                            span {{ this.votes.length }}
                            VotingSlider(slot="popover" :author="comment.author" :permlink="comment.permlink" @success="getAllProps()")
                    span.action
                        span(:class="{ 'no-payout': noPayout }") ${{ value.toFixed(2) }}
                    span.action
                        span.active-action(@click="openReplyForm()") Reply
                    span.action(v-if="comment.author == username")
                        span.active-action(@click="openEditForm()") Edit
            ReplyForm(
                v-if="isReplyFormOpened"
                :parent_author="comment.author"
                :parent_permlink="comment.permlink"
                @cancel="closeReplyForm()"
                @success="addReply($event, comment)")
            comments-tree(v-for="child in children" :comment="child")
</template>

<script lang="ts">
    import Vue from 'vue';
    import Vuex from 'vuex';

    import ReplyForm from './ReplyForm.vue';
    import EditForm from './EditForm.vue';
    import VotingSlider from './VotingSlider.vue';
    import CommentsService from "../../services/CommentsService";
    import VotingService from "../../services/VotingService";
    import moment = require("moment");

    export default Vue.extend({
        name: "comments-tree",
        components: {
            ReplyForm,
            EditForm,
            VotingSlider
        },
        props: {
            comment: {
                type: Object,
                required: true
            },
            isRoot: {
                type: Boolean,
                required: true,
                default: false
            }
        },

        data() {
            return {
                children: [],
                votes: [],
                value: 0,
                expanded: true,
                isReplyFormOpened: false,
                isEditActive: false,
                isHidden: false
            }
        },

        methods: {
            openReplyForm() {
                if(this.isLoggedIn) {
                    this.isReplyFormOpened = true;
                }
            },
            closeReplyForm() {
                this.isReplyFormOpened = false;
            },
            openEditForm() {
                if(this.isLoggedIn) {
                    this.isEditActive = true;
                }
            },
            closeEditForm() {
                this.isEditActive = false;
            },
            showHidden() {
                this.isHidden = false;
            },
            addReply(reply: any, comment: any) {
                console.log(reply, comment);
                this.children.push({
                    parent_permlink: comment.permlink,
                    parent_author: comment.author,
                    permlink: reply.permlink,
                    author: reply.author,
                    title: reply.title,
                    body: reply.body,
                    rendered: reply.rendered,
                    created: moment.utc().format(),
                    net_votes: 0,
                    pending_payout_value: '0.000 SBD',
                    total_payout_value: '0.000 SBD'

                })
                this.closeReplyForm();
            },
            updateComment(rendered: string) {
                this.isEditActive = false;
                this.comment.rendered = rendered;
            },
            getVoters() {
                CommentsService.getVotes(this.$props.comment.author, this.$props.comment.permlink)
                    .then((votes: any) => {
                        this.votes = votes;
                    }).catch((error: Error) => {
                    console.error(error);
                })
            },
            getValue() {
                VotingService.getValue(this.$props.comment.author, this.$props.comment.permlink)
                    .then( (value: number) => {
                        this.value = value;
                    })
            },
            getAllProps() {
                this.getVoters();
                this.getValue();
            }

        },

        computed: {
            createdLocalTime() {
                return moment.utc(this.comment.created).local()
            },
            username() {
                return this.$store.state.sso.username;
            },
            isLoggedIn() {
                return !!this.username;
            },
            next() {
                return {
                    permlink: this.comment.permlink,
                    author: this.comment.author
                }
            },
            label() {
                return this.comment.permlink + this.comment.author;
            },
            noPayout() {
                return this.comment.max_accepted_payout === '0.000 SBD';
            },
            hasLowRating() {
                return this.comment.net_rshares < 0;
            },
            isVotedByUser() {
                if (!this.username) {
                    return false;
                } else {
                    const voted = this.votes.reduce((voted: boolean, vote: any) => voted || vote.voter === this.username, false);
                    return voted;
                }
            }
        },

        mounted(): void {
            console.log('mounted', this.comment);

            if (this.hasLowRating) {
                this.isHidden = true;
            }

            this.getAllProps();

            if (this.$props.comment.author && this.$props.comment.permlink && this.$props.comment.children) {
                CommentsService.getComments(this.$props.comment.author, this.$props.comment.permlink)
                    .then((response: any) => {
                        console.log('got replies', response.data);
                        this.children = response.data
                    })
            }

        },
    })

</script>

<style scoped>
    .comments .comments-tree {
        list-style-type: none;
        padding: 0;
        margin-left: 85px;
    }

    .comments > .comments-tree {
        list-style-type: none;
        padding: 0;
        margin-left: 0px;
    }

    .comments .comment-meta {
        font-size: 13px;
        color: rgb(170, 170, 170);
        padding-bottom: 8px;
        margin-top: 4px;
        margin-bottom: 10px !important;
        border-bottom: 1px solid rgb(238, 238, 238);
    }

    img.comment-avatar {
        position: relative;
        float: left;
        margin-left: 0;
        margin-top: 0;
        width: 65px;
        height: 65px;
    }

    .comment-content {
        border: 1px solid #eee;
        margin-bottom: 20px;
        margin-left: 85px;
        margin-right: 0px;
        padding: 10px 20px;
        position: relative;
        -webkit-border-radius: 4px;
        -moz-border-radius: 4px;
        -o-border-radius: 4px;
        border-radius: 4px;
        background: #fff;
        color: #6b6e80;
        position: relative;
    }

    .comment-actions {
        margin-bottom: 0px;
    }

    .no-payout {
        text-decoration-line: line-through;
    }

    .action {
        padding-right: 15px;
    }

    .active-action {
        cursor: pointer;
    }
    .comment-meta-username {
        color: #aaa;
    }
    .voted {
        color: green;
    }

    .low-rating {
        color: #aaa;
    }

    @media only screen and (max-width: 768px) {

        .comments .comments-tree {
            list-style-type: none;
            padding: 0;
            margin-left: 25px;
        }

        .comments > .comments-tree {
            list-style-type: none;
            padding: 0;
            margin-left: 0px;
        }

        img.comment-avatar {
            width: 20px;
            height: 20px;
        }

        .comment-content {
            margin-left: 25px;
        }
    }
</style>
